Skip to main content
Redhat Developers  Logo
  • AI

    Get started with AI

    • Red Hat AI
      Accelerate the development and deployment of enterprise AI solutions.
    • AI learning hub
      Explore learning materials and tools, organized by task.
    • AI interactive demos
      Click through scenarios with Red Hat AI, including training LLMs and more.
    • AI/ML learning paths
      Expand your OpenShift AI knowledge using these learning resources.
    • AI quickstarts
      Focused AI use cases designed for fast deployment on Red Hat AI platforms.
    • No-cost AI training
      Foundational Red Hat AI training.

    Featured resources

    • OpenShift AI learning
    • Open source AI for developers
    • AI product application development
    • Open source-powered AI/ML for hybrid cloud
    • AI and Node.js cheat sheet

    Red Hat AI Factory with NVIDIA

    • Red Hat AI Factory with NVIDIA is a co-engineered, enterprise-grade AI solution for building, deploying, and managing AI at scale across hybrid cloud environments.
    • Explore the solution
  • Learn

    Self-guided

    • Documentation
      Find answers, get step-by-step guidance, and learn how to use Red Hat products.
    • Learning paths
      Explore curated walkthroughs for common development tasks.
    • See all learning

    Hands-on

    • Developer Sandbox
      Spin up Red Hat's products and technologies without setup or configuration.
    • Interactive labs
      Learn by doing in these hands-on, browser-based experiences.
    • Interactive demos
      Click through product features in these guided tours.

    Browse by topic

    • AI/ML
    • Automation
    • Java
    • Kubernetes
    • Linux
    • See all topics

    Training & certifications

    • Courses and exams
    • Certifications
    • Skills assessments
    • Red Hat Academy
    • Learning subscription
    • Explore training
  • Build

    Get started

    • Red Hat build of Podman Desktop
      A downloadable, local development hub to experiment with our products and builds.
    • Developer Sandbox
      Spin up Red Hat's products and technologies without setup or configuration.

    Download products

    • Access product downloads to start building and testing right away.
    • Red Hat Enterprise Linux
    • Red Hat AI
    • Red Hat OpenShift
    • Red Hat Ansible Automation Platform
    • See all products

    Featured

    • Red Hat build of OpenJDK
    • Red Hat JBoss Enterprise Application Platform
    • Red Hat OpenShift Dev Spaces
    • Red Hat Developer Toolset

    References

    • E-books
    • Documentation
    • Cheat sheets
    • Architecture center
  • Community

    Get involved

    • Events
    • Live AI events
    • Red Hat Summit
    • Red Hat Accelerators
    • Community discussions

    Follow along

    • Articles & blogs
    • Developer newsletter
    • Videos
    • Github

    Get help

    • Customer service
    • Customer support
    • Regional contacts
    • Find a partner

    Join the Red Hat Developer program

    • Download Red Hat products and project builds, access support documentation, learning content, and more.
    • Explore the benefits

Configuring NGINX to log HTTP POST data on Linux / RHEL

May 23, 2016
Bachir Chihani
Related topics:
Linux
Related products:
Red Hat Enterprise Linux

    NGINX is a powerful web server that can easily handle high volumes of HTTP traffic. Each time NGINX handles a connection, a log entry is generated to store some information this connection like remote IP address, response size and status code, etc. The complete set of logged information with more details can be found here.

    In some cases, you may be more interested in storing the body of requests, specifically POST requests. Lucky, the NGINX ecosystem is rich, and includes quite a few handy modules. One such module is the Echo module, which provides useful functionality for things like: echo, time, and sleep commands.

    In our use case, to log a request body, what we need is to use the echo_read_request_body command and the $request_body variable (contains the request body of the Echo module). However, this module is not distributed with NGINX by default, and to be able to use it we have to build NGINX from its source code by building it with the source code of the Echo module included. 

    The following steps detail how to build NGINX so that the Echo module is included (here is the complete build bash file):

    Download the source codes for NGINX and Echo using the following commands:

    curl -L -O 'https://github.com/openresty/echo-nginx-module/archive/v0.58.tar.gz'
    tar -xzvf v0.58.tar.gz && rm v0.58.tar.gz
    mv echo-nginx-module-0.58 /tmp/echo-nginx-module
    curl -O 'http://nginx.org/download/nginx-1.9.7.tar.gz'
    tar -xzvf nginx-1.9.7.tar.gz && rm nginx-1.9.7.tar.gz

    Create an nginx user, which we will use to run the NGINX process:

    groupadd nginx
    useradd -G nginx nginx

    Install NGINX from source code:

    cd nginx-1.9.7/ && ./configure \
     --user=nginx \
     --group=nginx \
     --prefix=/etc/nginx \
     --sbin-path=/usr/sbin/nginx \
     --conf-path=/etc/nginx/nginx.conf \
     --pid-path=/var/run/nginx.pid \
     --lock-path=/var/run/nginx.lock \
     --error-log-path=/var/log/nginx/error.log \
     --http-log-path=/var/log/nginx/access.log \
     --with-http_gzip_static_module \
     --with-http_stub_status_module \
     --with-http_ssl_module \
     --with-pcre \
     --with-file-aio \
     --with-http_realip_module \
     --add-module=/tmp/echo-nginx-module
    
    make -j2
    make install

    Now NGINX is ready to start, but before doing so we need to modify the default NGINX configuration file under /etc/nginx/nginx.conf to enable logging of the HTTP request body.

    NGINX writes quite a bit of information about incoming requests to the location indicated in the access_log directive. What is and is not logged in each log event can be customized in the log_format directive. Further, the Echo module stores the request body in the request_body variable by calling the echo_read_request_body method. We have to modify these directives as follows (here is the complete nginx.conf):

    http {
     ...
     log_format custom '$request_body';
     access_log /var/log/nginx/access.log custom;
     ...
     server {
      location / {
       echo_read_request_body;
        ...
      } 
     }
    }

    If you are in a high-throughput environment, you may need to increase the allowed limit of linux open files, for user nginx in order to be able to handle thousands of requests per second. You can do so by using the following commands to append this setting to your configurations (you can also edit the files directly):

    echo "fs.file-max = 1073741824" >> /etc/sysctl.conf
    echo "nginx soft nofile 40960" >> /etc/security/limits.conf
    echo "nginx hard nofile 81920" >> /etc/security/limits.conf

    Now, we are ready to start NGINX and log incoming HTTP requests' body. Run NGINX:

    nginx

    I hope this helps give an understanding of how to control some of the NGINX logging functionality, and how to build, install, and utilize the Echo module. The complete script and details can be found in this gist.

     

    Last updated: October 18, 2018

    Recent Posts

    • Federated identity across the hybrid cloud using zero trust workload identity manager

    • Confidential virtual machine storage attack scenarios

    • Introducing virtualization platform autopilot

    • Integrate zero trust workload identity manager with Red Hat OpenShift GitOps

    • Best Practice Configuration and Tuning for Linux and Windows VMs

    Red Hat Developers logo LinkedIn YouTube Twitter Facebook

    Platforms

    • Red Hat AI
    • Red Hat Enterprise Linux
    • Red Hat OpenShift
    • Red Hat Ansible Automation Platform
    • See all products

    Build

    • Developer Sandbox
    • Developer tools
    • Interactive tutorials
    • API catalog

    Quicklinks

    • Learning resources
    • E-books
    • Cheat sheets
    • Blog
    • Events
    • Newsletter

    Communicate

    • About us
    • Contact sales
    • Find a partner
    • Report a website issue
    • Site status dashboard
    • Report a security problem

    RED HAT DEVELOPER

    Build here. Go anywhere.

    We serve the builders. The problem solvers who create careers with code.

    Join us if you’re a developer, software engineer, web designer, front-end designer, UX designer, computer scientist, architect, tester, product manager, project manager or team lead.

    Sign me up

    Red Hat legal and privacy links

    • About Red Hat
    • Jobs
    • Events
    • Locations
    • Contact Red Hat
    • Red Hat Blog
    • Inclusion at Red Hat
    • Cool Stuff Store
    • Red Hat Summit
    © 2026 Red Hat

    Red Hat legal and privacy links

    • Privacy statement
    • Terms of use
    • All policies and guidelines
    • Digital accessibility

    Chat Support

    Please log in with your Red Hat account to access chat support.